# wxGauge Class Reference
[Controls]

`#include <wx/gauge.h>`

Inheritance diagram for wxGauge:
[legend]

## Detailed Description

A gauge is a horizontal or vertical bar which shows a quantity (often time).

wxGauge supports two working modes: determinate and indeterminate progress.

The first is the usual working mode (see SetValue() and SetRange()) while the second can be used when the program is doing some processing but you don't know how much progress is being done. In this case, you can periodically call the Pulse() function to make the progress bar switch to indeterminate mode (graphically it's usually a set of blocks which move or bounce in the bar control).

wxGauge supports dynamic switch between these two work modes.

There are no user commands for the gauge.

## Styles

This class supports the following styles:

- wxGA_HORIZONTAL:
  Creates a horizontal gauge.
- wxGA_VERTICAL:
  Creates a vertical gauge.
- wxGA_SMOOTH:
  Creates smooth progress bar with one pixel wide update step (not supported by all platforms).

##

Library: wxCore

Category: Controls
Appearance:

wxMSW appearance | wxGTK appearance | wxMac appearance

See also:
  wxSlider, wxScrollBar

## Public Member Functions
| wxGauge ()
| Default constructor.
| wxGauge (wxWindow *parent, wxWindowID id, int range, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxGA_HORIZONTAL, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxGaugeNameStr)
| Constructor, creating and showing a gauge.
virtual | ~wxGauge ()
| Destructor, destroying the gauge.
bool | Create (wxWindow *parent, wxWindowID id, int range, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxGA_HORIZONTAL, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxGaugeNameStr)
| Creates the gauge for two-step construction.
int | GetBezelFace () const
| Returns the width of the 3D bezel face.
int | GetRange () const
| Returns the maximum position of the gauge.
int | GetShadowWidth () const
| Returns the 3D shadow margin width.
int | GetValue () const
| Returns the current position of the gauge.
bool | IsVertical () const
| Returns true if the gauge is vertical (has `wxGA_VERTICAL` style) and false otherwise.
virtual void | Pulse ()
| Switch the gauge to indeterminate mode (if required) and makes the gauge move a bit to indicate the user that some progress has been made.
void | SetBezelFace (int width)
| Sets the 3D bezel face width.
void | SetRange (int range)
| Sets the range (maximum value) of the gauge.
void | SetShadowWidth (int width)
| Sets the 3D shadow width.
void | SetValue (int pos)
| Sets the position of the gauge.

List of all members.

## Constructor & Destructor Documentation

wxGauge::wxGauge | ( |  | ) |

Default constructor.

wxGauge::wxGauge | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | int | range,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxGA_HORIZONTAL`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxGaugeNameStr` |
| ) |  |  |

Constructor, creating and showing a gauge.

Parameters:

  | parent | Window parent.
  | id | Window identifier.
  | range | Integer range (maximum value) of the gauge. See SetRange() for more details about the meaning of this value when using the gauge in indeterminate mode.
  | pos | Window position.
  | size | Window size.
  | style | Gauge style.
  | validator | Window validator.
  | name | Window name.

See also:
  Create()

virtual wxGauge::~wxGauge | ( |  | ) | `[virtual]`

Destructor, destroying the gauge.

## Member Function Documentation

bool wxGauge::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | int | range,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxGA_HORIZONTAL`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxGaugeNameStr` |
| ) |  |  |

Creates the gauge for two-step construction.

See wxGauge() for further details.

int wxGauge::GetBezelFace | ( |  | ) | const

Returns the width of the 3D bezel face.

Remarks:
  This method is not implemented (returns 0) for most platforms.

See also:
  SetBezelFace()

int wxGauge::GetRange | ( |  | ) | const

Returns the maximum position of the gauge.

See also:
  SetRange()

int wxGauge::GetShadowWidth | ( |  | ) | const

Returns the 3D shadow margin width.

Remarks:
  This method is not implemented (returns 0) for most platforms.

See also:
  SetShadowWidth()

int wxGauge::GetValue | ( |  | ) | const

Returns the current position of the gauge.

See also:
  SetValue()

bool wxGauge::IsVertical | ( |  | ) | const

Returns true if the gauge is vertical (has `wxGA_VERTICAL` style) and false otherwise.

virtual void wxGauge::Pulse | ( |  | ) | `[virtual]`

Switch the gauge to indeterminate mode (if required) and makes the gauge move a bit to indicate the user that some progress has been made.

Note:
  After calling this function the value returned by GetValue() is undefined and thus you need to explicitly call SetValue() if you want to restore the determinate mode.

void wxGauge::SetBezelFace | ( | int | width | ) |

Sets the 3D bezel face width.

Remarks:
  This method is not implemented (doesn't do anything) for most platforms.

See also:
  GetBezelFace()

void wxGauge::SetRange | ( | int | range | ) |

Sets the range (maximum value) of the gauge.

This function makes the gauge switch to determinate mode, if it's not already.

When the gauge is in indeterminate mode, under wxMSW the gauge repeatedly goes from zero to range and back; under other ports when in indeterminate mode, the range setting is ignored.

See also:
  GetRange()

void wxGauge::SetShadowWidth | ( | int | width | ) |

Sets the 3D shadow width.

Remarks:
  This method is not implemented (doesn't do anything) for most platforms.

void wxGauge::SetValue | ( | int | pos | ) |

Sets the position of the gauge.

The pos must be between 0 and the gauge range as returned by GetRange(), inclusive.

This function makes the gauge switch to determinate mode, if it was in indeterminate mode before.

Parameters:

  | pos | Position for the gauge level.

See also:
  GetValue()

|  | [ top ]